/*
  ==============================================================================

    This file was auto-generated!

    It contains the basic framework code for a JUCE plugin editor.

  ==============================================================================
*/

#include "PluginProcessor.h"
#include "PluginEditor.h"

//==============================================================================
ClassTestAudioProcessorEditor::ClassTestAudioProcessorEditor (ClassTestAudioProcessor& p)
    : AudioProcessorEditor (&p), processor (p)
{
    // Make sure that before the constructor has finished, you've set the
    // editor's size to whatever you need it to be.
    setSize (324, 182);
    
    gainSlider.setRange(-60.0, 48.0);
    gainSlider.setSliderStyle (Slider::RotaryHorizontalVerticalDrag);
    gainSlider.setTextBoxStyle (Slider::TextBoxBelow, false, 100, 20);
    addAndMakeVisible(&gainSlider);
    gainSlider.addListener(this);
    gainSliderAttachment = new AudioProcessorValueTreeState::SliderAttachment (processor.parameters, "gain", gainSlider);
    
    freqSlider.setRange(0.01, 30.0);
    freqSlider.setSkewFactor(0.3, false);
    freqSlider.setSliderStyle (Slider::RotaryHorizontalVerticalDrag);
    freqSlider.setTextBoxStyle (Slider::TextBoxBelow, false, 100, 20);
    addAndMakeVisible(&freqSlider);
    freqSlider.addListener(this);
    freqSliderAttachment = new AudioProcessorValueTreeState::SliderAttachment (processor.parameters, "freq", freqSlider);

    depthSlider.setRange(0.0, 100.0);
    depthSlider.setSliderStyle (Slider::RotaryHorizontalVerticalDrag);
    depthSlider.setTextBoxStyle (Slider::TextBoxBelow, false, 100, 20);
    addAndMakeVisible(&depthSlider);
    depthSlider.addListener(this);
    depthSliderAttachment = new AudioProcessorValueTreeState::SliderAttachment (processor.parameters, "depth", depthSlider);
    

}

ClassTestAudioProcessorEditor::~ClassTestAudioProcessorEditor()
{
    gainSliderAttachment = nullptr;
    freqSliderAttachment = nullptr;
    depthSliderAttachment = nullptr;
}

//==============================================================================
void ClassTestAudioProcessorEditor::paint (Graphics& g)
{
    // (Our component is opaque, so we must completely fill the background with a solid colour)
    g.fillAll (getLookAndFeel().findColour (ResizableWindow::backgroundColourId));

    g.setColour(Colours::blanchedalmond);
    g.drawRect(3, 3, 318, 176);
    g.setFont(30.0);
    g.setColour(Colours::lightblue);
    g.drawText(TRANS("fuzz trem"), 6, 6, 312, 30, Justification::centred); // left, top, width, height

    g.setFont(20.0);
    g.setColour(Colours::limegreen);
    g.drawText(TRANS("gain"), 6, 156, 100, 20, Justification::centred); // left, top, width, height
    g.drawText(TRANS("mod freq"), 112, 156, 100, 20, Justification::centred); // left, top, width, height
    g.drawText(TRANS("mod depth"), 218, 156, 100, 20, Justification::centred); // left, top, width, height

  }

void ClassTestAudioProcessorEditor::resized()
{
    // This is generally where you'll want to lay out the positions of any
    // subcomponents in your editor..
    gainSlider.setBounds (6, 30, 100, 120); // left, top, width, height
    freqSlider.setBounds (112, 30, 100, 120); // left, top, width, height
    depthSlider.setBounds (218, 30, 100, 120); // left, top, width, height
}

void ClassTestAudioProcessorEditor::sliderValueChanged(Slider* sliderThatWasMoved)
{
 //   if(sliderThatWasMoved == &gainSlider)
 //       processor.gain = gainSlider.getValue() * 10.0;
}
